Subject: Re: bug#22763: 25.1.50; Feature Request -- A faster method to obtain line number at position.

From: Eli Zaretskii <[email-masked]>
Date: Mon, 08 Feb 2021 17:04:58 +0200

> From: Lars Ingebrigtsen <[email-masked]>
> Cc: [email-masked],  [email-masked],  [email-masked]
> Date: Sun, 07 Feb 2021 22:36:12 +0100
> 
> > It exists to support the line-number display on the mode line.  That
> > display has its own cache, as part of the window object, so
> > display_count_lines very rarely needs to count from the beginning of
> > the buffer, it usually counts from the last place it stopped the
> > previous time for the same window.  This is why it has the signature
> > that it has.
> 
> But these are the signatures:
> 
> ptrdiff_t
> find_newline (ptrdiff_t start, ptrdiff_t start_byte, ptrdiff_t end,
> 	      ptrdiff_t end_byte, ptrdiff_t count, ptrdiff_t *counted,
> 	      ptrdiff_t *bytepos, bool allow_quit)
> 
> 
> static ptrdiff_t
> display_count_lines (ptrdiff_t start_byte,
> 		     ptrdiff_t limit_byte, ptrdiff_t count,
> 		     ptrdiff_t *byte_pos_ptr)
> 
> So they seem very similar...

I was trying to explain why display_count_lines accepts arguments that
may seem unnecessary at first sight if the job is to just count the
lines.

> Anyway, here's something that just occurred to me: It's still the plan
> to have so-long-mode on by default, right?  Which means that
> 'buffer-line-statistics' will be called when opening a file, which means
> that we know whether there are any long lines in the buffer.
> 
> Could we use this info to switch between cached and non-cached action
> for find_newline?  (I.e., just set 'cache-long-scans'.)

It isn't as easy as it may sound, because cache-long-scans also
affects another cache, the one used by bidi.c.  We need to be able to
turn them on and off separately to be able to support what you
suggest.

> Conversely, could we use find_newline to trigger so-long-mode?  Today,
> so-long-mode isn't able to step into the fray when something plops a
> long line into the buffer (in shell-mode, for instance).  If
> find_newline finds a long line, it could switch 'cache-long-scans' on,
> and also (on perhaps a different threshold) notify so-long-mode?

We already detect overlong lines: that's when the line number on the
mode line becomes "??".  We just need to use that as trigger for
so-long-mode, if we want it to turn on automatically.  Also, we need
to consider whether the same threshold as the one we use for the
mode-line display of line numbers is suitable for so-long-mode, or we
need two separate thresholds.